<!--
/********************************************************************************
 * Copyright © 2020 Basys GmbH.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 ********************************************************************************/
-->

<label class="field-label" [for]="controlId">
  <ng-content></ng-content>
</label>

<div [formGroup]="form" class="field-control">

  <ng-template #inputTemplateRef>
    <input [id]="controlId"
           autocomplete="off"
           class="form-control"
           [formControlName]="'' + key">
  </ng-template>

  <span class="field-control-input-container" *ngIf="displayAddButton || displayCancelButton; else inputTemplateRef;">
    <ng-container [ngTemplateOutlet]="inputTemplateRef"></ng-container>
    <button *ngIf="displayAddButton"
            [disabled]="form.disabled"
            (click)="add.emit()"
            class="pi pi-plus btn btn-link field-control-input-btn"
            type="button">
    </button>
    <button *ngIf="displayCancelButton"
            [disabled]="form.disabled"
            (click)="cancel.emit()"
            class="pi pi-times btn btn-link field-control-input-btn"
            type="button">
    </button>
  </span>

  <ok-error [control]="form?.get([key])"></ok-error>
</div>
